Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/CzechAddressPlugin.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/CzechAddressPlugin.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/CzechAddressPlugin.java	(revision 15582)
@@ -31,9 +31,11 @@
 import org.openstreetmap.josm.plugins.czechaddress.actions.FactoryAction;
 import org.openstreetmap.josm.plugins.czechaddress.actions.HelpAction;
-import org.openstreetmap.josm.plugins.czechaddress.actions.ModifierAction;
+import org.openstreetmap.josm.plugins.czechaddress.actions.ManagerAction;
 import org.openstreetmap.josm.plugins.czechaddress.actions.SplitAreaByEmptyWayAction;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.Street;
 import org.openstreetmap.josm.plugins.czechaddress.gui.ConflictResolver;
 import org.openstreetmap.josm.plugins.czechaddress.gui.FactoryDialog;
 import org.openstreetmap.josm.plugins.czechaddress.gui.LocationSelector;
+import org.openstreetmap.josm.plugins.czechaddress.gui.ManagerDialog;
 import org.openstreetmap.josm.plugins.czechaddress.intelligence.Reasoner;
 import org.openstreetmap.josm.plugins.czechaddress.intelligence.SelectionMonitor;
@@ -82,9 +84,12 @@
         addStatusListener(this);
         
-        Reasoner.getInstance();
         ConflictResolver.getInstance();
         SelectionMonitor.getInstance();
+        FactoryDialog.getInstance();
+        Reasoner.getInstance();
 
-        initLoggers();
+        boolean assertionsEnabled = false;
+        assert assertionsEnabled = true;
+        if (assertionsEnabled) initLoggers();
         
         MainMenu.add(Main.main.menu.toolsMenu, new SplitAreaByEmptyWayAction());
@@ -94,6 +99,4 @@
         parser.setTargetDatabase(Database.getInstance());
         parser.setStorageDir(getPluginDir());
-
-        parser.setFilter("HUSTOPEČE", "HUSTOPEČE", null, null);
 
         // Fill the database in separate thread.
@@ -130,20 +133,19 @@
             reasoner.reset();
             reasoner.openTransaction();
-            //Reasoner.logger.setLevel(Level.OFF);
             for (House house : location.getAllHouses())
-                reasoner.consider(house);
+                reasoner.update(house);
+
+            for (Street street : location.getAllStreets())
+                reasoner.update(street);
+
             for (OsmPrimitive prim : Main.ds.allPrimitives()) {
-                boolean include = false;
-                for (String key : prim.keySet())
-                    if (key.startsWith("addr:")) {
-                        include = true;
-                        break;
-                    }
-                if (include)
-                    reasoner.consider(prim);
+                if (House.isMatchable(prim) || Street.isMatchable(prim))
+                    reasoner.update(prim);
             }
-            //Reasoner.logger.setLevel(Level.ALL);
             reasoner.closeTransaction();
         }
+        ManagerDialog dialog = new ManagerDialog();
+        if (dialog.countAutomaticRenameProposals() > 0)
+            dialog.setVisible(true);
     }
 
@@ -178,5 +180,5 @@
             menuItems.add(MainMenu.add(czechMenu, new GroupManipulatorAction()));
             menuItems.add(MainMenu.add(czechMenu, new ConflictResolveAction()));
-            menuItems.add(MainMenu.add(czechMenu, new ModifierAction()));
+            menuItems.add(MainMenu.add(czechMenu, new ManagerAction()));
             menuItems.add(MainMenu.add(czechMenu, new HelpAction()));
             return;
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/PrimUtils.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/PrimUtils.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/PrimUtils.java	(revision 15582)
@@ -7,8 +7,5 @@
 
 import java.util.Comparator;
-import org.openstreetmap.josm.data.coor.LatLon;
-import org.openstreetmap.josm.data.osm.Node;
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
-import org.openstreetmap.josm.data.osm.Way;
 
 /**
@@ -16,5 +13,8 @@
  * @author Radomír Černoch, radomir.cernoch@gmail.com
  */
-public class PrimUtils implements Comparator<OsmPrimitive> {
+public class PrimUtils {
+
+    public static final String KEY_HIGHWAY      = "highway";
+    public static final String KEY_PLACE        = "place";
 
     public static final String KEY_ADDR_CP      = "addr:alternatenumber";
@@ -28,34 +28,43 @@
 
     private static final String[] keysToCompare = new String[]
-        {KEY_ADDR_COUNTRY, KEY_ADDR_CITY, KEY_IS_IN,
-         KEY_ADDR_STREET, KEY_ADDR_CO, KEY_ADDR_CP, KEY_NAME };
+        {KEY_PLACE, KEY_NAME, KEY_ADDR_COUNTRY, KEY_ADDR_CITY, KEY_IS_IN,
+         KEY_ADDR_STREET, KEY_ADDR_CO, KEY_ADDR_CP };
 
-    public int compare(OsmPrimitive o1, OsmPrimitive o2) {
+    public static final Comparator<OsmPrimitive> comparator =
+        new Comparator<OsmPrimitive>() {
 
-        for (String key : keysToCompare) {
-            if (o1.get(key) == null) continue;
-            if (o2.get(key) == null) continue;
+        public int compare(OsmPrimitive o1, OsmPrimitive o2) {
 
-            int val = o1.get(key).compareTo(o2.get(key));
-            if (val != 0) return val;
-        }
+            for (String key : keysToCompare) {
+                if (o1.get(key) == null) {
+                    continue;
+                }
+                if (o2.get(key) == null) {
+                    continue;
+                }
 
+                int val = o1.get(key).compareTo(o2.get(key));
+                if (val != 0) {
+                    return val;
+                }
+            }
 
-        return o1.toString().compareTo(o2.toString());
+            return o1.toString().compareTo(o2.toString());
 
-        /*LatLon pos1 = null;
-        LatLon pos2 = null;
-        if (o1 instanceof Node) pos1 = ((Node) o1).coor;
-        if (o1 instanceof Way)  pos1 = ((Way)  o1).lastNode().coor;
-        if (o2 instanceof Node) pos1 = ((Node) o2).coor;
-        if (o2 instanceof Way)  pos1 = ((Way)  o2).lastNode().coor;
+            /*LatLon pos1 = null;
+            LatLon pos2 = null;
+            if (o1 instanceof Node) pos1 = ((Node) o1).coor;
+            if (o1 instanceof Way)  pos1 = ((Way)  o1).lastNode().coor;
+            if (o2 instanceof Node) pos1 = ((Node) o2).coor;
+            if (o2 instanceof Way)  pos1 = ((Way)  o2).lastNode().coor;
 
-        if (pos1 != null && pos2 != null) {
+            if (pos1 != null && pos2 != null) {
             if (pos1.lat() < pos2.lat()) return -1;
             if (pos1.lat() > pos2.lat()) return  1;
             if (pos1.lon() < pos2.lon()) return -1;
             if (pos1.lon() > pos2.lon()) return  1;
-        }*/
-    }
+            }*/
+        }
+    };
 
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/StringUtils.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/StringUtils.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/StringUtils.java	(revision 15582)
@@ -1,4 +1,5 @@
 package org.openstreetmap.josm.plugins.czechaddress;
 
+import java.text.Normalizer;
 import org.openstreetmap.josm.data.coor.LatLon;
 
@@ -50,12 +51,12 @@
 
     /**
-     * String matcher with abbreviations
+     * String matcher with abbreviations and regardless of diacritics.
      *
-     * <p>Returns {@code true} even if s1="Nám. Svobody" and
+     * <p>Returns {@code true} even if s1="Nam. Svobody" and
      * s2="Náměstí Svobody".</p>
      */
     public static boolean matchAbbrev(String s1, String s2) {
-        String[] parts1 = s1.split(" +");
-        String[] parts2 = s2.split(" +");
+        String[] parts1 = anglicize(s1).split(" +");
+        String[] parts2 = anglicize(s2).split(" +");
 
         if (parts1.length != parts2.length)
@@ -110,5 +111,5 @@
         }
 
-        String[] noCapitalize = { "Nad", "Pod", "U", "Na" };
+        String[] noCapitalize = { "Nad", "Pod", "U", "Na", "Z" };
         for (String noc : noCapitalize)
             result = result.replaceAll(" "+noc+" ", " "+noc.toLowerCase()+" ");
@@ -116,3 +117,23 @@
         return result;
     }
+
+    /**
+     * Remove diacritics from the string.
+     *
+     * <p>This method was posted on the
+     * <a href='http://forums.sun.com/thread.jspa?messageID=10190825#10190825'>
+     * SUN forum</a> by
+     * <a href='http://forums.sun.com/profile.jspa?userID=43408'>
+     * <i>Alan Moore</i></a>.</p>
+     */
+    public static String anglicize(String str) {
+        String strNFD = Normalizer.normalize(str, Normalizer.Form.NFD);
+        StringBuilder sb = new StringBuilder();
+        for (char ch : strNFD.toCharArray()) {
+            if (Character.getType(ch) != Character.NON_SPACING_MARK) {
+                sb.append(ch);
+            }
+        }
+        return sb.toString();
+    }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/FactoryAction.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/FactoryAction.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/FactoryAction.java	(revision 15582)
@@ -9,5 +9,4 @@
 import org.openstreetmap.josm.data.osm.Node;
 import org.openstreetmap.josm.gui.MapFrame;
-import org.openstreetmap.josm.plugins.czechaddress.CzechAddressPlugin;
 import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.House;
 import org.openstreetmap.josm.plugins.czechaddress.intelligence.Reasoner;
@@ -99,9 +98,10 @@
             r.closeTransaction();
         }
+        
+        FactoryDialog.getInstance().selectionListenerActivated = false;
         FactoryDialog.getInstance().selectNextUnmatchedHouseByCheckBox();
-
-        // And make the new node selected.
-        Main.ds.addPrimitive(newNode);
+        Main.ds.addPrimitive(newNode);        
         Main.ds.setSelected(newNode);
+        FactoryDialog.getInstance().selectionListenerActivated = true;
     }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/ManagerAction.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/ManagerAction.java	(revision 15582)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/ManagerAction.java	(revision 15582)
@@ -0,0 +1,28 @@
+package org.openstreetmap.josm.plugins.czechaddress.actions;
+
+import java.awt.event.ActionEvent;
+import java.awt.event.KeyEvent;
+import org.openstreetmap.josm.actions.JosmAction;
+import org.openstreetmap.josm.plugins.czechaddress.gui.ManagerDialog;
+import org.openstreetmap.josm.tools.Shortcut;
+
+/**
+ *
+ * @author Radomír Černoch, radomir.cernoch@gmail.com
+ */
+public class ManagerAction extends JosmAction {
+
+    public ManagerAction() {
+        super("Upravit databázi",
+              null,//"envelope-closed-big.png",
+              "Upravit jména elemntů dle mapy",
+              Shortcut.registerShortcut("address:assignaddress",
+                        "Adresy: Přiřadit adresy",
+                        KeyEvent.VK_P, Shortcut.GROUP_DIRECT, Shortcut.SHIFT_DEFAULT),
+              true);
+    }
+
+    public void actionPerformed(ActionEvent e) {
+        (new ManagerDialog()).setVisible(true);
+    }
+}
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/AddressElement.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/AddressElement.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/AddressElement.java	(revision 15582)
@@ -6,5 +6,5 @@
 import org.openstreetmap.josm.data.osm.Way;
 import org.openstreetmap.josm.plugins.czechaddress.StringUtils;
-import org.openstreetmap.josm.plugins.czechaddress.intelligence.Match;
+import org.openstreetmap.josm.plugins.czechaddress.intelligence.Reasoner;
 import org.openstreetmap.josm.plugins.czechaddress.proposal.Proposal;
 
@@ -206,4 +206,8 @@
     }
 
+    protected int[] getAdditionalFieldMatchList(OsmPrimitive primitive) {
+        int[] result = {0};
+        return result;
+    }
 
     public List<Proposal> getDiff(OsmPrimitive prim) {
@@ -211,5 +215,5 @@
     }
 
-    public int getMatchQuality(OsmPrimitive primitive) {
+    public int getQ(OsmPrimitive primitive) {
         
         // Firstly get integers representing a match of every matchable field.
@@ -234,5 +238,5 @@
         // has nothing to do with our field.
         if (maxVal <= 0)
-            return Match.MATCH_NOMATCH;
+            return Reasoner.MATCH_NOMATCH;
         
         // If all fields are 1    --> ROCKSOLID MATCH
@@ -240,36 +244,10 @@
         // If some are 1, some -1 --> CONFLICT
         switch (minVal * maxVal) {
-            case -1 : return Match.MATCH_CONFLICT;
-            case  0 : return Match.MATCH_PARTIAL;
-            case +1 : return Match.MATCH_ROCKSOLID;   
+            case -1 : return Reasoner.MATCH_CONFLICT;
+            case  0 : return Reasoner.MATCH_PARTIAL;
+            case +1 : return Reasoner.MATCH_ROCKSOLID;
         }
         
         return 0; // <-- just to make compilers happy. We cannot get here.
-    }
-
-
-
-    public String getIsIn() {
-        return getIsIn(null);
-    }
-
-    protected String getIsInName() {
-        return getName();
-    }
-
-    private String getIsIn(String childString) {
-
-        String result = "";
-
-        if (getIsInName() != null  &&  !getIsInName().equals(childString)) {
-            result += getIsInName() + ", ";
-        }
-
-        if (parent != null)
-            result += parent.getIsIn(getIsInName());
-        else
-            result += "CZ";
-        
-        return result;
     }
 
@@ -282,5 +260,5 @@
         if (retVal != 0) return retVal;
 
-        return getName().compareTo(((AddressElement) elem).getName());
+        return toString().compareTo(((AddressElement) elem).toString());
     }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ElementWithHouses.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ElementWithHouses.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ElementWithHouses.java	(revision 15582)
@@ -9,5 +9,5 @@
  * @author Radomir Cernoch radomir.cernoch@gmail.com
  */
-abstract public class ElementWithHouses extends AddressElement {
+public abstract class ElementWithHouses extends AddressElement {
 
     /**
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ElementWithStreets.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ElementWithStreets.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ElementWithStreets.java	(revision 15582)
@@ -16,5 +16,5 @@
  * @author Radomir Cernoch radomir.cernoch@gmail.com
  */
-abstract public class ElementWithStreets extends ElementWithHouses {
+public abstract class ElementWithStreets extends ElementWithHouses {
 
     private ArrayList<Street> streets = new ArrayList<Street>();
@@ -60,4 +60,9 @@
     }
 
+    public List<Street> getAllStreets() {
+        return getStreets();
+    }
+
+
     public Street findStreet(String streetName) {
 
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/House.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/House.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/House.java	(revision 15582)
@@ -5,5 +5,4 @@
 import org.openstreetmap.josm.plugins.czechaddress.NotNullList;
 import org.openstreetmap.josm.plugins.czechaddress.PrimUtils;
-import org.openstreetmap.josm.plugins.czechaddress.StringUtils;
 import org.openstreetmap.josm.plugins.czechaddress.proposal.Proposal;
 
@@ -133,5 +132,5 @@
      * {@link AddressElement}{@code .getFieldMatchList()}.</p>
      *
-     * <p>First elemtn of the returned array corresponds to the CP
+     * <p>First element of the returned array corresponds to the CP
      * (číslo popisné), the second one to the combination of Street+CO.</p>
      */
@@ -139,5 +138,6 @@
     protected int[] getFieldMatchList(OsmPrimitive prim) {
         int[] result = {0, 0};
-                
+        if (!isMatchable(prim)) return result;
+
         // First field is the AlternateNubmer
         result[0] = matchField(this.cp, prim.get(PrimUtils.KEY_ADDR_CP));
@@ -150,5 +150,17 @@
         return result;
     }
+
+    @Override
+    protected int[] getAdditionalFieldMatchList(OsmPrimitive prim) {
+        int[] result = {0};
+        if (!isMatchable(prim)) return result;
+
+        ParentResolver resolver = new ParentResolver(this);
+        result[0] = matchField(resolver.getIsIn(), prim.get(PrimUtils.KEY_IS_IN));
+        return result;
+    }
+
     
+
     /**
      * Gives all proposals to make the primitive be an address primitive.
@@ -161,5 +173,5 @@
         
         List<Proposal> props = new NotNullList<Proposal>();
-        ParentResolver pr = new ParentResolver(this);
+        ParentResolver resolver = new ParentResolver(this);
 
         props.add(getStringFieldDiff(PrimUtils.KEY_ADDR_CP, prim.get(PrimUtils.KEY_ADDR_CP), getCP()));
@@ -169,13 +181,15 @@
                             prim.get(PrimUtils.KEY_ADDR_COUNTRY), "CZ"));
 
-        if (pr.parentStreet != null)
+        if (resolver.parentStreet != null)
             props.add(getStringFieldDiff(PrimUtils.KEY_ADDR_STREET,
                                 prim.get(PrimUtils.KEY_ADDR_STREET),
-                                pr.parentStreet.getName()));
-
-        if (parent.parent != null) // For sure our parent is a ElemWithStreets
+                                resolver.parentStreet.getName()));
+
+        AddressElement isInElem = parent;
+        if (isInElem instanceof Street) isInElem = parent.parent;
+        if (isInElem != null) // For sure our parent is a ElemWithStreets
             props.add(getStringFieldDiff(PrimUtils.KEY_IS_IN,
                                 prim.get(PrimUtils.KEY_IS_IN),
-                                parent.parent.getIsIn()));
+                                resolver.getIsIn()));
 
         // If we have added any proposal so far, add the source info as well.
@@ -187,10 +201,7 @@
 
     public static boolean isMatchable(OsmPrimitive prim) {
-        
-        for (String key : prim.keySet()) {
-            String value = prim.get(key);
-            if (value != null && value.startsWith("addr:"))
+        for (String key : prim.keySet())
+            if (key.startsWith("addr:"))
                 return true;
-        }
         return false;
     }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ParentResolver.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ParentResolver.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ParentResolver.java	(revision 15582)
@@ -40,4 +40,27 @@
     }
 
+    public String getIsIn() {
+        String result = "";
+        String last = "";
+
+        if (parentSuburb != null && !last.equals(parentSuburb.getName())) {
+            result += parentSuburb.getName() + ", ";
+            last = parentSuburb.getName();
+        }
+
+        if (parentViToCi != null && !last.equals(parentViToCi.getName())) {
+            result += parentViToCi.getName() + ", ";
+            last = parentViToCi.getName();
+        }
+
+        if (parentRegion != null && parentRegion.getNuts3Name() != null &&
+                                    !last.equals(parentRegion.getNuts3Name())) {
+            result += parentRegion.getNuts3Name() + " kraj, ";
+            last = parentRegion.getNuts3Name();
+        }
+
+        return result + "CZ";
+    }
+
     public int compareTo(ParentResolver o) {
         int val = 0;
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Region.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Region.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Region.java	(revision 15582)
@@ -95,15 +95,3 @@
         return thisString;
     }
-
-    @Override
-    protected String getIsInName() {
-
-        if (nuts3name != null)
-            return nuts3name + " kraj";
-
-        if (nuts4name != null)
-            return nuts3name + " okres";
-
-        return null;
-    }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Street.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Street.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Street.java	(revision 15582)
@@ -1,5 +1,11 @@
 package org.openstreetmap.josm.plugins.czechaddress.addressdatabase;
 
+import java.util.List;
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
+import org.openstreetmap.josm.plugins.czechaddress.NotNullList;
+import org.openstreetmap.josm.plugins.czechaddress.PrimUtils;
+import org.openstreetmap.josm.plugins.czechaddress.proposal.Proposal;
+
+import static org.openstreetmap.josm.plugins.czechaddress.proposal.ProposalFactory.getStringFieldDiff;
 
 /**
@@ -29,20 +35,21 @@
     protected int[] getFieldMatchList(OsmPrimitive primitive) {
         int[] result = {0};
+        if (!isMatchable(primitive)) return result;
         
-        if (primitive.get("highway") == null)
-            return result;
-        
-        result[0] = matchField(name, primitive.get("name"));
-
-        if (primitive.get("name") != null) {
-            String[] parts1 = primitive.get("name").split("\\.* +");
-            String[] parts2 =                  name.split("\\.* +");
-            for (String p : parts1)
-                System.out.println("X: " + p);
-            for (String p : parts2)
-                System.out.println("Y: " + p);
-        }
-
+        result[0] = matchFieldAbbrev(name, primitive.get("name"));
         return result;
     }
+
+    @Override
+    public List<Proposal> getDiff(OsmPrimitive prim) {
+        List<Proposal> props = new NotNullList<Proposal>();
+        
+        props.add(getStringFieldDiff(PrimUtils.KEY_NAME, prim.get(PrimUtils.KEY_NAME), getName()));
+        return props;
+    }
+
+    public static boolean isMatchable(OsmPrimitive prim) {
+        return (prim.get(PrimUtils.KEY_HIGHWAY) != null);
+    }
+
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Suburb.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Suburb.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Suburb.java	(revision 15582)
@@ -1,3 +1,6 @@
 package org.openstreetmap.josm.plugins.czechaddress.addressdatabase;
+
+import org.openstreetmap.josm.data.osm.OsmPrimitive;
+import org.openstreetmap.josm.plugins.czechaddress.PrimUtils;
 
 /**
@@ -11,3 +14,10 @@
         super(name);
     }
+
+    public static boolean isMatchable(OsmPrimitive prim) {
+        for (String key : prim.keySet())
+            if (key.equals(PrimUtils.KEY_PLACE))
+                return true;
+        return false;
+    }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ViToCi.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ViToCi.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/ViToCi.java	(revision 15582)
@@ -3,5 +3,4 @@
 import java.util.List;
 import java.util.ArrayList;
-import org.openstreetmap.josm.data.osm.OsmPrimitive;
 
 /**
@@ -56,3 +55,19 @@
         return null;
     }
+
+    @Override
+    public List<Street> getAllStreets() {
+        List<Street> result = super.getAllStreets();
+        for (Suburb suburb : suburbs)
+            result.addAll(suburb.getAllStreets());
+        return result;
+    }
+
+    @Override
+    public List<House> getAllHouses() {
+        List<House> result = super.getAllHouses();
+        for (Suburb suburb : suburbs)
+            result.addAll(suburb.getAllHouses());
+        return result;
+    }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ConflictResolver.form
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ConflictResolver.form	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ConflictResolver.form	(revision 15582)
@@ -156,4 +156,7 @@
             <Property name="enabled" type="boolean" value="false"/>
           </Properties>
+          <Events>
+            <EventHandler event="actionPerformed" listener="java.awt.event.ActionListener" parameters="java.awt.event.ActionEvent" handler="candPickButtonActionPerformed"/>
+          </Events>
         </Component>
         <Component class="javax.swing.JButton" name="mainPickButton">
